[openwrt/openwrt] ath79: Add support for OpenMesh OM2P v4

LEDE Commits lede-commits at lists.infradead.org
Mon Dec 28 13:49:25 EST 2020


adrian pushed a commit to openwrt/openwrt.git, branch master:
https://git.openwrt.org/dd1d95cb0357278900d09fae3ad20e9e0b2d569a

commit dd1d95cb0357278900d09fae3ad20e9e0b2d569a
Author: Sven Eckelmann <sven at narfation.org>
AuthorDate: Mon Nov 23 13:41:34 2020 +0100

    ath79: Add support for OpenMesh OM2P v4
    
    Device specifications:
    ======================
    
    * Qualcomm/Atheros QCA9533 v2
    * 650/600/217 MHz (CPU/DDR/AHB)
    * 64 MB of RAM
    * 16 MB of SPI NOR flash
      - 2x 7 MB available; but one of the 7 MB regions is the recovery image
    * 2x 10/100 Mbps Ethernet
    * 1T1R 2.4 GHz Wi-Fi
    * 6x GPIO-LEDs (3x wifi, 2x ethernet, 1x power)
    * 1x GPIO-button (reset)
    * external h/w watchdog (enabled by default)
    * TTL pins are on board (arrow points to VCC, then follows: GND, TX, RX)
    * 2x fast ethernet
      - eth0
        + Label: Ethernet 1
        + 24V passive POE (mode B)
      - eth1
        + Label: Ethernet 2
        + 802.3af POE
        + builtin switch port 1
    * 12-24V 1A DC
    * external antenna
    
    Flashing instructions:
    ======================
    
    Various methods can be used to install the actual image on the flash.
    Two easy ones are:
    
    ap51-flash
    ----------
    
    The tool ap51-flash (https://github.com/ap51-flash/ap51-flash) should be
    used to transfer the image to the u-boot when the device boots up.
    
    initramfs from TFTP
    -------------------
    
    The serial console must be used to access the u-boot shell during bootup.
    It can then be used to first boot up the initramfs image from a TFTP server
    (here with the IP 192.168.1.21):
    
       setenv serverip 192.168.1.21
       setenv ipaddr 192.168.1.1
       tftpboot 0c00000 <filename-of-initramfs-kernel>.bin && bootm $fileaddr
    
    The actual sysupgrade image can then be transferred (on the LAN port) to
    the device via
    
      scp <filename-of-squashfs-sysupgrade>.bin root at 192.168.1.1:/tmp/
    
    On the device, the sysupgrade must then be started using
    
      sysupgrade -n /tmp/<filename-of-squashfs-sysupgrade>.bin
    
    Signed-off-by: Sven Eckelmann <sven at narfation.org>
    [wrap two very long lines, fix typo in comment]
    Signed-off-by: Adrian Schmutzler <freifunk at adrianschmutzler.de>
---
 package/boot/uboot-envtools/Makefile               |   2 +-
 package/boot/uboot-envtools/files/ath79            |   1 +
 .../linux/ath79/dts/qca9533_openmesh_om2p-v4.dts   |   8 ++
 .../linux/ath79/dts/qca9533_openmesh_om2p-v4.dtsi  | 157 +++++++++++++++++++++
 .../ath79/generic/base-files/etc/board.d/01_leds   |   4 +
 .../generic/base-files/etc/board.d/02_network      |   1 +
 .../generic/base-files/lib/upgrade/openmesh.sh     | 112 +++++++++++++++
 .../generic/base-files/lib/upgrade/platform.sh     |   4 +
 target/linux/ath79/image/generic.mk                |  20 +++
 9 files changed, 308 insertions(+), 1 deletion(-)

diff --git a/package/boot/uboot-envtools/Makefile b/package/boot/uboot-envtools/Makefile
index 590e38d883..4d2b03e33c 100644
--- a/package/boot/uboot-envtools/Makefile
+++ b/package/boot/uboot-envtools/Makefile
@@ -10,7 +10,7 @@ include $(TOPDIR)/rules.mk
 PKG_NAME:=uboot-envtools
 PKG_DISTNAME:=u-boot
 PKG_VERSION:=2020.04
-PKG_RELEASE:=9
+PKG_RELEASE:=10
 
 PKG_SOURCE:=$(PKG_DISTNAME)-$(PKG_VERSION).tar.bz2
 PKG_SOURCE_URL:= \
diff --git a/package/boot/uboot-envtools/files/ath79 b/package/boot/uboot-envtools/files/ath79
index 1eaaa06f0e..ba857e54ed 100644
--- a/package/boot/uboot-envtools/files/ath79
+++ b/package/boot/uboot-envtools/files/ath79
@@ -85,6 +85,7 @@ netgear,wndr4300tn|\
 netgear,wndr4300sw)
 	ubootenv_add_uci_config "/dev/mtd1" "0x0" "0x40000" "0x20000"
 	;;
+openmesh,om2p-v4|\
 plasmacloud,pa300|\
 plasmacloud,pa300e)
 	ubootenv_add_uci_config "/dev/mtd1" "0x0" "0x40000" "0x40000"
diff --git a/target/linux/ath79/dts/qca9533_openmesh_om2p-v4.dts b/target/linux/ath79/dts/qca9533_openmesh_om2p-v4.dts
new file mode 100644
index 0000000000..b738afad33
--- /dev/null
+++ b/target/linux/ath79/dts/qca9533_openmesh_om2p-v4.dts
@@ -0,0 +1,8 @@
+// SPDX-License-Identifier: GPL-2.0-or-later OR MIT
+
+#include "qca9533_openmesh_om2p-v4.dtsi"
+
+/ {
+	compatible = "openmesh,om2p-v4", "qca,qca9533";
+	model = "OpenMesh OM2P v4";
+};
diff --git a/target/linux/ath79/dts/qca9533_openmesh_om2p-v4.dtsi b/target/linux/ath79/dts/qca9533_openmesh_om2p-v4.dtsi
new file mode 100644
index 0000000000..74daba3f93
--- /dev/null
+++ b/target/linux/ath79/dts/qca9533_openmesh_om2p-v4.dtsi
@@ -0,0 +1,157 @@
+// SPDX-License-Identifier: GPL-2.0-or-later OR MIT
+
+#include "qca953x.dtsi"
+
+#include <dt-bindings/gpio/gpio.h>
+#include <dt-bindings/input/input.h>
+
+/ {
+	chosen {
+		/delete-property/ bootargs;
+	};
+
+	aliases {
+		led-boot = &led_power_blue;
+		led-failsafe = &led_power_blue;
+		led-running = &led_power_blue;
+		led-upgrade = &led_power_blue;
+		label-mac-device = &eth0;
+	};
+
+	keys {
+		compatible = "gpio-keys";
+
+		pinctrl-names = "default";
+		pinctrl-0 = <&jtag_disable_pins>;
+
+		reset {
+			label = "reset";
+			linux,code = <KEY_RESTART>;
+			gpios = <&gpio 1 GPIO_ACTIVE_LOW>;
+		};
+	};
+
+	leds {
+		compatible = "gpio-leds";
+
+		led_power_blue: power_blue {
+			label = "blue:power";
+			gpios = <&gpio 0 GPIO_ACTIVE_LOW>;
+			default-state = "on";
+		};
+
+		wifi_green {
+			label = "green:wifi";
+			gpios = <&gpio 2 GPIO_ACTIVE_LOW>;
+			linux,default-trigger = "phy0tpt";
+		};
+
+		wifi_yellow {
+			label = "yellow:wifi";
+			gpios = <&gpio 3 GPIO_ACTIVE_LOW>;
+		};
+
+		wifi_red {
+			label = "red:wifi";
+			gpios = <&gpio 4 GPIO_ACTIVE_LOW>;
+		};
+
+		wan_blue {
+			label = "blue:wan";
+			gpios = <&gpio 13 GPIO_ACTIVE_LOW>;
+		};
+
+		lan_blue {
+			label = "blue:lan";
+			gpios = <&gpio 14 GPIO_ACTIVE_LOW>;
+		};
+	};
+
+	watchdog {
+		compatible = "linux,wdt-gpio";
+		gpios = <&gpio 12 GPIO_ACTIVE_LOW>;
+		hw_algo = "toggle";
+		/* hw_margin_ms is actually 300s but driver limits it to 60s */
+		hw_margin_ms = <60000>;
+		always-running;
+	};
+};
+
+&uart {
+	status = "okay";
+};
+
+&spi {
+	status = "okay";
+
+	flash at 0 {
+		compatible = "jedec,spi-nor";
+		reg = <0>;
+		spi-max-frequency = <25000000>;
+
+		/* partitions are passed via bootloader */
+		partitions {
+			compatible = "fixed-partitions";
+			#address-cells = <1>;
+			#size-cells = <1>;
+
+			partition at 0 {
+				label = "u-boot";
+				reg = <0x000000 0x040000>;
+				read-only;
+			};
+
+			partition at 40000 {
+				label = "u-boot-env";
+				reg = <0x040000 0x040000>;
+			};
+
+			partition at 80000 {
+				label = "custom";
+				reg = <0x080000 0x140000>;
+				read-only;
+			};
+
+			partition at 1c0000 {
+				label = "inactive";
+				reg = <0x1c0000 0x700000>;
+			};
+
+			partition at 8c0000 {
+				label = "inactive2";
+				reg = <0x8c0000 0x700000>;
+			};
+
+			art: partition at fc0000 {
+				label = "ART";
+				reg = <0xfc0000 0x040000>;
+				read-only;
+			};
+		};
+	};
+};
+
+&eth0 {
+	status = "okay";
+
+	phy-handle = <&swphy4>;
+
+	mtd-mac-address = <&art 0x0>;
+};
+
+&eth1 {
+	/* Workaround: keep the Ethernet interfaces order/mapping correct
+	 * (GMAC0 -> eth0, GMAC1 -> eth1, same as in old ar71xx target)
+	 */
+	compatible = "qca,qca9530-eth", "syscon", "simple-mfd";
+
+	mtd-mac-address = <&art 0x6>;
+};
+
+&wmac {
+	status = "okay";
+
+	mtd-cal-data = <&art 0x1000>;
+	mtd-mac-address = <&art 0x0>;
+	mtd-mac-address-increment = <2>;
+};
diff --git a/target/linux/ath79/generic/base-files/etc/board.d/01_leds b/target/linux/ath79/generic/base-files/etc/board.d/01_leds
index 443cccce81..8095712e88 100755
--- a/target/linux/ath79/generic/base-files/etc/board.d/01_leds
+++ b/target/linux/ath79/generic/base-files/etc/board.d/01_leds
@@ -230,6 +230,10 @@ netgear,wnr2200-16m)
 	ucidef_set_led_switch "lan3amber" "LAN3 (amber)" "amber:lan3" "switch0" "0x08" "0x02"
 	ucidef_set_led_switch "lan4amber" "LAN4 (amber)" "amber:lan4" "switch0" "0x10" "0x02"
 	;;
+openmesh,om2p-v4)
+	ucidef_set_led_netdev "wan" "WAN" "blue:wan" "eth0"
+	ucidef_set_led_switch "lan" "LAN" "blue:lan" "switch0" "0x02"
+	;;
 pcs,cr3000)
 	ucidef_set_led_netdev "wan" "WAN" "blue:wan" "eth1"
 	ucidef_set_led_switch "lan1" "LAN1" "blue:lan1" "switch0" "0x04"
diff --git a/target/linux/ath79/generic/base-files/etc/board.d/02_network b/target/linux/ath79/generic/base-files/etc/board.d/02_network
index 14e858b8fa..fa98b18e59 100755
--- a/target/linux/ath79/generic/base-files/etc/board.d/02_network
+++ b/target/linux/ath79/generic/base-files/etc/board.d/02_network
@@ -152,6 +152,7 @@ ath79_setup_interfaces()
 	comfast,cf-e120a-v3|\
 	comfast,cf-e314n-v2|\
 	compex,wpj531-16m|\
+	openmesh,om2p-v4|\
 	plasmacloud,pa300|\
 	plasmacloud,pa300e|\
 	tplink,cpe210-v1|\
diff --git a/target/linux/ath79/generic/base-files/lib/upgrade/openmesh.sh b/target/linux/ath79/generic/base-files/lib/upgrade/openmesh.sh
new file mode 100644
index 0000000000..35a4ccfbfe
--- /dev/null
+++ b/target/linux/ath79/generic/base-files/lib/upgrade/openmesh.sh
@@ -0,0 +1,112 @@
+# The U-Boot loader of the OpenMesh devices requires image sizes and
+# checksums to be provided in the U-Boot environment.
+# The OpenMesh devices come with 2 main partitions - while one is active
+# sysupgrade will flash the other. The boot order is changed to boot the
+# newly flashed partition. If the new partition can't be booted due to
+# upgrade failures the previously used partition is loaded.
+
+cfg_value_get()
+{
+	local cfg=$1 cfg_opt
+	local section=$2 our_section=0
+	local param=$3 our_param=
+
+	for cfg_opt in $cfg; do
+		[ "$cfg_opt" = "[$section]" ] && our_section=1 && continue
+		[ "$our_section" = "1" ] || continue
+
+		our_param=${cfg_opt%%=*}
+		[ "$param" = "$our_param" ] && echo ${cfg_opt##*=} && break
+	done
+}
+
+platform_do_upgrade_openmesh()
+{
+	local img_path="$1"
+	local restore_backup
+
+	local setenv_script="/tmp/fw_env_upgrade"
+
+	local inactive_mtd="$(find_mtd_index $PART_NAME)"
+	local inactive_offset="$(cat /sys/class/mtd/mtd${inactive_mtd}/offset)"
+	local total_size="$(cat /sys/class/mtd/mtd${inactive_mtd}/size)"
+	local flash_start_mem=0x9f000000
+	local data_offset=$((64 * 1024))
+
+	# detect to which flash region the new image is written to.
+	#
+	# 1. check what is the mtd index for the first flash region on this
+	#    device
+	# 2. check if the target partition ("inactive") has the mtd index of
+	#    the first flash region
+	#
+	#    - when it is: the new bootseq will be 1,2 and the first region is
+	#      modified
+	#    - when it isn't: bootseq will be 2,1 and the second region is
+	#      modified
+	#
+	# The detection has to be done via the hardcoded mtd partition because
+	# the current boot might be done with the fallback region. Let us
+	# assume that the current bootseq is 1,2. The bootloader detected that
+	# the image in flash region 1 is corrupt and thus switches to flash
+	# region 2. The bootseq in the u-boot-env is now still the same and
+	# the sysupgrade code can now only rely on the actual mtd indexes and
+	# not the bootseq variable to detect the currently booted flash
+	# region/image.
+	#
+	# In the above example, an implementation which uses bootseq ("1,2") to
+	# detect the currently booted image would assume that region 1 is booted
+	# and then overwrite the variables for the wrong flash region (aka the
+	# one which isn't modified). This could result in a device which doesn't
+	# boot anymore to Linux until it was reflashed with ap51-flash.
+	local next_boot_part="1"
+	local primary_kernel_mtd="3"
+	[ "$inactive_mtd" = "$primary_kernel_mtd" ] || next_boot_part="2"
+
+	local cfg_size=$(dd if="$img_path" bs=2 skip=35 count=4 2>/dev/null)
+	local cfg_length=$((0x$cfg_size))
+	local cfg_content=$(dd if="$img_path" bs=1 skip=$data_offset count=$cfg_length 2>/dev/null)
+
+	local kernel_size=$(dd if="$img_path" bs=2 skip=71 count=4 2>/dev/null)
+	local kernel_length=$((0x$kernel_size))
+	local kernel_md5=$(cfg_value_get "$cfg_content" "vmlinux" "md5sum")
+
+	local rootfs_size=$(dd if="$img_path" bs=2 skip=107 count=4 2>/dev/null)
+	local rootfs_length=$((0x$rootfs_size))
+	local rootfs_md5=$(cfg_value_get "$cfg_content" "rootfs" "md5sum")
+	local rootfs_checksize=$(cfg_value_get "$cfg_content" "rootfs" "checksize")
+
+	# take care of restoring a saved config
+	[ -n "$UPGRADE_BACKUP" ] && restore_backup="${MTD_CONFIG_ARGS} -j ${UPGRADE_BACKUP}"
+
+	# write image parts
+	mtd -q erase inactive
+	dd if="$img_path" bs=1 skip=$((data_offset + cfg_length + kernel_length)) count=$rootfs_length 2>&- | \
+		mtd -n -p $kernel_length $restore_backup write - $PART_NAME
+	dd if="$img_path" bs=1 skip=$((data_offset + cfg_length)) count=$kernel_length 2>&- | \
+		mtd -n write - $PART_NAME
+
+	# prepare new u-boot env
+	if [ "$next_boot_part" = "1" ]; then
+		echo "bootseq 1,2" > $setenv_script
+	else
+		echo "bootseq 2,1" > $setenv_script
+	fi
+
+	printf "kernel_size_%i %i\n" $next_boot_part $((kernel_length / 1024)) >> $setenv_script
+	printf "vmlinux_start_addr 0x%08x\n" $((flash_start_mem + inactive_offset)) >> $setenv_script
+	printf "vmlinux_size 0x%08x\n" ${kernel_length} >> $setenv_script
+	printf "vmlinux_checksum %s\n" ${kernel_md5} >> $setenv_script
+
+	printf "rootfs_size_%i %i\n" $next_boot_part $(((total_size-kernel_length) / 1024)) >> $setenv_script
+	printf "rootfs_start_addr 0x%08x\n" $((flash_start_mem+inactive_offset+kernel_length)) >> $setenv_script
+	printf "rootfs_size %s\n" $rootfs_checksize >> $setenv_script
+	printf "rootfs_checksum %s\n" ${rootfs_md5} >> $setenv_script
+
+	# store u-boot env changes
+	mkdir -p /var/lock
+	fw_setenv -s $setenv_script || {
+		echo "failed to update U-Boot environment"
+		return 1
+	}
+}
diff --git a/target/linux/ath79/generic/base-files/lib/upgrade/platform.sh b/target/linux/ath79/generic/base-files/lib/upgrade/platform.sh
index 98861685dc..88dac75301 100644
--- a/target/linux/ath79/generic/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ath79/generic/base-files/lib/upgrade/platform.sh
@@ -50,6 +50,10 @@ platform_do_upgrade() {
 	jjplus,ja76pf2)
 		redboot_fis_do_upgrade "$1" linux
 		;;
+	openmesh,om2p-v4)
+		PART_NAME="inactive"
+		platform_do_upgrade_openmesh "$1"
+		;;
 	plasmacloud,pa300|\
 	plasmacloud,pa300e)
 		PART_NAME="inactive"
diff --git a/target/linux/ath79/image/generic.mk b/target/linux/ath79/image/generic.mk
index 63a07a9d5c..132bde73c4 100644
--- a/target/linux/ath79/image/generic.mk
+++ b/target/linux/ath79/image/generic.mk
@@ -1557,6 +1557,26 @@ define Device/ocedo_ursus
 endef
 TARGET_DEVICES += ocedo_ursus
 
+define Device/openmesh_om2p-common
+  DEVICE_VENDOR := OpenMesh
+  DEVICE_PACKAGES := uboot-envtools
+  IMAGE_SIZE := 7168k
+  BLOCKSIZE := 256k
+  KERNEL := kernel-bin | append-dtb | lzma | uImage lzma | \
+	pad-to $$(BLOCKSIZE)
+  IMAGE/sysupgrade.bin := append-rootfs | pad-rootfs | \
+	openmesh-image ce_type=OM2P | append-metadata
+endef
+
+define Device/openmesh_om2p-v4
+  $(Device/openmesh_om2p-common)
+  SOC := qca9533
+  DEVICE_MODEL := OM2P
+  DEVICE_VARIANT := v4
+  SUPPORTED_DEVICES += om2pv4
+endef
+TARGET_DEVICES += openmesh_om2p-v4
+
 define Device/openmesh_om5p-ac-v2
   SOC := qca9558
   DEVICE_VENDOR := OpenMesh



More information about the lede-commits mailing list